#ifndef __SimHelpH__
#define __SimHelpH__
// 2004 - Chaim Gingold


#include "shared/core/first.h"

#include "shared/physics/2d/2d_body_hull.h"
#include "shared/physics/2d/2d_body_list.h"
#include "shared/physics/2d/2d_body_box.h"
#include "shared/physics/2d/2d_body_sphere.h"

#include "shared/physics/2d/gl_physics2d_draw.h"
#include "shared/physics/2d/rigid/2d_rigid_sim.h"
#include "shared/physics/2d/rigid/2d_rigid_drag_force.h"
#include "shared/physics/2d/rigid/2d_rigid_control_force.h"
#include "shared/physics/2d/rigid/2d_rigid_gravity_force.h"
#include "shared/physics/2d/rigid/2d_rigid_spring_force.h"
#include "shared/physics/2d/rigid/2d_rigid_pt2pt_constraint.h"

#include "shared/math/vec2.h"

#include "fRect.h"


using namespace ajb ;
using namespace ajb::Physics::D2 ;
using namespace ajb::Physics::D2::Rigid ;

fPoint2 v2f ( Vec2 ) ;
Vec2    f2v ( fPoint2 ) ;
 
void FrameRigidBody ( Rigid_Body * ) ;
void PaintRigidBody ( Rigid_Body * ) ;

Rigid_Body* NewRigidCircle ( fPoint2 c, float r, float mass ) ;
Rigid_Body* NewRigidBox    ( fRect r ) ;
Rigid_Body* NewRigidPoly   ( fPoint2 * v, int n, float density=1.0f ) ;

fPoint2 ws2bs ( Rigid_Body *, fPoint2 wss ) ;
fPoint2 bs2ws ( Rigid_Body *, fPoint2 bs ) ;




#endif