#include "chaim.h"
#include "fTime.h"
#include "fColor.h"
#include "fRect.h"
// 2004 - Chaim Gingold

void DrawSun ( fPoint2 c, float radius )
{
	float v = fTime::Cycle(0,1) ;
		
	fColor::SetToBlend( fColor::yellow(), fColor::purple(), v ) ;
	
	PaintCircle( c, radius ) ;
	
	PenWidth( 4 ) ;
	
	fColor::SetToBlend( fColor::yellow(), fColor::purple(), 1-v ) ;
	
	const int n=10 ;

	fRad rotBase = DegToRad(360) * fTime::Rise( 0, 5 ) ;
			
	for( int i=0; i<n; i++ )
	{
		fRad rot = rotBase + DegToRad(360) * ( (float)i / (float)(n) ) ;
		
		fPoint2 p1( radius*1.2, 0 ) ;
		fPoint2 p2( radius*1.6, 0 ) ;
		
		p1.Rotate( rot ) ;
		p2.Rotate( rot ) ;

		p1.Add( c ) ;
		p2.Add( c ) ;
					
		Line( p1, p2 ) ;
	}
	
	PenWidth( 1 ) ;
}


void DrawFlower ( fPoint2 loc, float r, float length, int npetals )
{
	float sway  = pix(3) + -pix(6)*fTime::Cycle(0,5) ;
	fRad  swaya = DegToRad( 45 + -45*.5*fTime::Cycle(0,5) ) ;
	
	float pr = r/2 ;
	float cr = r/3 ;		
	
	fPoint2 top = loc ;
	top.y -= length ;
	top.x += sway ;		
	
	fRad tilt=0 ;

	/*if ( l == eShadowLayer )
	{
		float sc = .7 ; // might want to be a function of length -- distance from ground?

		fColor::SetToGray( .15 ) ;
		fPoint2 s = loc ;
		s.x += length/4 + sway/3 ;
		s.y += length/5 + sway/3 ;
		PaintCircle( s, cr * sc ) ;
		Line( loc, s ) ;
		
		for( int i=0; i<npetals; i++ )
		{
			fPoint2 p ;
			
			fRad a = swaya + tilt + kPI*2 * ( (float)i/(float)npetals ) ;
						
			p.SetPolar( s, a, (cr*2 + pr)*sc ) ;
			
			PaintCircle( p, pr*sc ) ;
		}
	}*/
	//else if ( l == eAgentLayer )
	{
		fColor::SetToBlend( fColor::green(), fColor::purple(), .1 ) ;
		//fColor::green()->SetColor() ;

		fPoint2 t ;
		
		t.SetPolar( top, top.Angle(loc), cr+pix(2) ) ;
			// add a little white space between stem and top
		
		PenWidth(3) ;
		Line( loc, t ) ;
		PenWidth(2) ;
	}
	//else if ( l == eAboveAgentLayer )
	{
		fColor::yellow()->SetColor() ;
		PaintCircle( top, cr ) ;
		//fColor::SetToGray( .15 ) ;
		//FrameCircle( top, cr ) ;
		
		fColor color ;
		color.SetToBetween( fColor::purple(), fColor::white(), .5 ) ;
		
		for( int i=0; i<npetals; i++ )
		{
			fRad a = swaya + tilt + kPI*2 * ( (float)i/(float)npetals ) ;
			
			float shadow = 1 - fPoint2::ArcDeltaAbs( a, kPI-kPI/4+kPI/2 ) / kPI/2 ;
			CLAMP( shadow, 0, 1 ) ;
			
			fColor::SetToBlend( &color, fColor::black(), .1 * shadow ) ;
			
			fPoint2 p ;
			p.SetPolar( top, a, cr*2 + pr ) ;
			PaintCircle( p, pr ) ;
		}
	}
}
