// 2004 - Chaim Gingold

#include <assert.h>
#include "SimHelp.h"
#include "../../utils/misc/framerate.h"
#include "shared/input/joystick.h"

#include "shared/input/keyboard.h"
#include "../../utils/media_lib/music.h"

Music music ;

// binding to the local GLUT framework
#include "chaim.h"

// Chaim's graphics utilities
#include "graphicsUtils.h"
#include "fColor.h"
#include "fRect.h"


#include "PlantSeg.h"

#include "Plant.h"




	/*
	 * Let's try the physics.
	 */

Spring_Force	* mouseSpring = 0 ;



	/*
	 *	Chaim's app
	 */

PlantWorld * gWorld = 0 ;

PlantObj * dragObj = 0 ;

float gFadeLevel = 0 ;

const int kMaxPlayers = 4 ;

int gNumPlayers = 2 ;

int curLevel = 0 ;

const fSec kLevelCompleteFade = 3 ;
fSec levelCompleteTime ;

int advanceLevel = 0 ;

//Music music ;


void AdvanceLevel ( void )
{
	levelCompleteTime = fTime::Get() ;
	advanceLevel++ ;
}

struct player
{
	player()
	{
		ant=0 ;
		score=0 ;
	}

	int score ;
	Ant * ant ;

} players[kMaxPlayers] ;


/*
struct Clouds
{
	

} clouds ;*/


void Start ( int level )
{
	JOYSTICK.init() ;

	gNumPlayers = min( kMaxPlayers, JOYSTICK.num_joysticks() ) ;

	level = level % kNumLevels ;

	curLevel= level ;

	if (gWorld) delete gWorld ;

	//
	for( int i=0; i<gNumPlayers; i++ ) players[i] = player() ;

	gWorld = new PlantWorld() ;

	gWorld->Init() ;

	gWorld->plant->GrowPlant(level) ;

	for( int i=0; i<gNumPlayers; i++ )
	{
		players[i].ant = gWorld->AddAnts( 1, GetBounds() ) ;
		players[i].ant->player = i ;
		players[i].ant->selected = 1 ;
	}
}

void InitChaim ( void )
{
	InitializeFrameRate(60.0f);

	Start(0) ;

	levelCompleteTime = fTime::Get() - kLevelCompleteFade/2 ;

    //music.init();
	//music.set_subdirectory("content/music/");
    //music.setupnotes();

	//HINSTANCE hInstance = static_cast<HINSTANCE>(GetModuleHandle(NULL)) ;
	//WND hWnd = static_cast<HWND>(GDK_WINDOW_HWND(gdkWinPtr)) ;

    //zsoundInit( 0 ) ; // GetForegroundWindow()

	//zsoundPlay("Music.wav", true, 1.0 ) ; //loop=true
	//wingsounds[0] = zsoundPlay("content/music/wings_1.wav", true, 0.0); //loop, volume0
	//wingsounds[1] = zsoundPlay("content/music/wings_2.wav", true, 0.0); //loop, volume0

    // music init
    music.init();
    music.set_subdirectory("./Sounds") ;
    music.setupnotes() ;
    music.loadseg( "Music",   "demo_a.sgt",   MUSIC_TRACK_MAIN ) ;
    music.loadseg( "LevelUp", "LevelUp.wav",  MUSIC_TRACK_MAIN ) ;
    music.loadseg( "Jump",    "Jump.wav",     MUSIC_TRACK_MAIN ) ;
    music.loadseg( "Pickup",  "OrangePickup.wav",    MUSIC_TRACK_MAIN ) ;
    music.loadseg( "Target",  "OrangeTarget.wav",    MUSIC_TRACK_MAIN ) ;

	music.play( "Music" ) ;
}

void MouseMoved ( fPoint2 delta )
{
/*	if ( dragObj )
	{
		dragObj->MoveTo( GetMouseLoc() ) ;
	}*/
 
	if ( mouseSpring ) mouseSpring->m_a = Handle( *gWorld->earth, f2v(GetMouseLoc()) ) ;
}

void MouseDown ( fPoint2 p )
{
	// move ants
	float d ;

	Rigid_Body *pb = gWorld->plant->FindClosestPlantBody( p, &d, 0 ) ;

	if ( d > kAntRadius ) pb = gWorld->earth ;

	fPoint2 q = ws2bs(pb,p) ;

	gWorld->CommandSelected( 1, Handle( *pb, f2v(q) ) ) ;

	//
	if ( gWorld->sim )
	{
		Vec2 body_space_position ;

		Rigid_Body * pick = gWorld->sim->pick( body_space_position, f2v(p) ) ;

		if ( pick )
		{
			mouseSpring = new Spring_Force(
				Handle( *gWorld->earth, f2v(GetMouseLoc()) ) ,
				Handle( *pick, body_space_position ) , 
				128.0f,		//Kspring
				32.0f,		//Kdamp
				0.0f		//rest length
			) ;

			if ( mouseSpring ) gWorld->sim -> add( *mouseSpring ) ;
		}
	}
}

void MouseUp ( fPoint2 )
{
	dragObj = 0 ;

	// nuke the mouse spring
	if ( mouseSpring )
	{
		assert( gWorld->sim ) ;

		gWorld->sim -> remove( *mouseSpring ) ;

		delete mouseSpring ;

		mouseSpring = 0 ;
	}
}

static bool swapPlayers = false ;


void Render ( void )
{
	// background
	if (1)
	{
		int k = 8 ;

		fRect b = GetBounds() ;

		float h = GetBounds().GetHeight() / k ;

		for( int i=0; i<k; i++ )
		{
			fRect r = b ;

			r.top = (float)i * h ;
			r.bottom = r.top + h ;

			float f = 1 - (float)i/(float)(k-1) ;

			f = .3 + .25*f ;

			if ( curLevel%2==0 )
			{
				fColor::SetToBlend( fColor::white(), fColor::blue(), f ) ;
			}
			else
			{
				fColor::SetToBlend( fColor::black(), fColor::blue(), 1-f ) ;
			}

			r.Paint() ;
		}
	}

	// flowers == num levels completed
	{
		for( int i=0; i<=curLevel; i++ )
		{
			fPoint2 p( pix(46) + pix(64)*i, gWorld->groundBounds.top ) ;

			DrawFlower( p, pix(16), pix(64), 4 + i%3 ) ;
		}
	}

	// world
	gWorld->RenderObjs() ;

	// debug pinning code
	if (0)
	{
		fPoint2 p = GetMouseLoc() ;
		
		float d = pix(8) ;

		if ( gWorld->PinToEdge( &p, d ) )
		{
			fColor::red()->SetColor() ;
			PaintCircle( p, d ) ;
		}
	}


	// Draw frame
	if (0)
	{
		SetOpacity(.25) ;

		if ( swapPlayers ) fColor::SetToGray(.5) ;
		else fColor::SetToBlend( fColor::red(), fColor::white(), .5 ) ;

		PenWidth(2) ;
		fRect b = GetBounds() ;
		b.Inset( pix(2), pix(2) ) ;
		b.Frame() ;
		PenWidth(2) ;

		SetOpacity(1) ;
	}



	// Draw status
	SetType( kBigType ) ;

	if ( curLevel%2==0 )
	{
		fColor::black()->SetColor() ;
	}
	else fColor::white()->SetColor() ;

	//fDrawString( pix(16), pix(32), "Score: %d", players[0].score ) ;

	//fDrawString( fPoint2( GetBounds().GetCenterX(), pix(32)), 0, "Level %d", curLevel+1 ) ;
	fDrawString( fPoint2( pix(16), pix(32)), -1, "Level %d", curLevel+1 ) ;

	//fDrawString( fPoint2( GetBounds().right-pix(16), pix(32) ), 1, "Score: %d", players[1].score ) ;


	// foreground
	{
		float f = fTime::Since( levelCompleteTime, kLevelCompleteFade ) ;

		if ( f >= .5 && advanceLevel )
		{
			Start( curLevel + advanceLevel ) ;
			advanceLevel = 0 ;
		}

		if ( f > .5 ) f = 1 - f ;

		f *= 2 ;

		gFadeLevel = f ;

		SetOpacity(f) ;
		fColor::white()->SetColor() ;
		GetBounds().Paint() ;
		SetOpacity(1) ;
	}
}

void StepGame ( void ) ;

void Idle ( void )
{
	if ( GetStartButton(0) || GetStartButton(1) || KEYBOARD.is_down(' ') || KEYBOARD.is_down(13) )
	{
		// restart
		Start( curLevel ) ;
		levelCompleteTime = fTime::Get() - kLevelCompleteFade/2 ;
	}

	// player beat level?
	if ( gWorld->plant->CountFruitSlots()==0 && advanceLevel==0 ) 
	{
		AdvanceLevel() ;
	}

	if ( GetSelectButton(0) || GetSelectButton(1) )
	{	
		AdvanceLevel() ;
	}

	StepGame() ;
}

void StepGame ( void )
{
	// apply forces to ant
	for( int i=0; i<gNumPlayers; i++ )
	{
		const float k = 48 ;

		int j = swapPlayers ? 1-i : i ;

		if ( players[j].ant )
		{
			int jumpButton = GetXButton(j) ;

			players[j].ant -> letGo = jumpButton ? 10 : players[j].ant -> letGo ;
			players[j].ant -> push  = false ; //GetOButton(j) ;

			if ( jumpButton ) music.overlay( "Jump", 0 ) ;

			//if ( !letGo )
			{
				fPoint2 p = GetLeftStick(j) ;

				p.Scale( pix(k), pix(k) ) ;

				players[j].ant -> WalkRelative(p) ;
			}
		}
	}

	//
	if ( gWorld->sim )
	{
		//gWorld->sim -> step( kSimTimeStep ) ;

   int const NumberOfSimSteps = 2;
    for(int StepCounter = 0;StepCounter < NumberOfSimSteps;++StepCounter) {
        // step as many times as you like
        gWorld->sim->step(1/(NumberOfSimSteps*GetFrameRate()));
        // do any game stuff you want here (like per-step collision response, etc.)
    }
    // now wait for the rest of the time so we're consistent on fast machines
    WaitFrameRate(GetFrameRate());

	}
	
	gWorld->UpdateObjs() ;
	
}